package org.jsonddl.model;
/**
   * A model represents a single kind of object within the schema. There is a
   * 1:1 correspondence between Models and Java classes or JS type closures.
   */
@javax.annotation.Generated(value="org.jsonddl.generator.industrial.IndustrialDialect", date="2012-06-23T18:24:31")
public interface Model
    extends org.jsonddl.JsonDdlObject<Model>
 {
  /**
   * Constructs instances of {@link Model}. Instances of Builder should not be
   * reused after calling {@link #build()}.
   */
  @javax.annotation.Generated(value="org.jsonddl.generator.industrial.IndustrialDialect", date="2012-06-23T18:24:31")
  public static class Builder
      implements org.jsonddl.JsonDdlObject.Builder<Model>,  org.jsonddl.impl.Traversable<Model>, org.jsonddl.impl.Digested, Model {
    private ModelImpl obj;
    public Builder() {
      this(new ModelImpl());
    }
    Builder(ModelImpl instance) {
      this.obj = instance;
    }
    public Model.Builder accept(org.jsonddl.JsonDdlVisitor visitor) {
      obj = new org.jsonddl.impl.ContextImpl.ObjectContext.Builder<Model>()
          .withValue(this)
          .withKind(org.jsonddl.model.Kind.DDL)
          .withMutability(true)
          .build().traverse(visitor).builder().obj;
      return this;
    }
    public Model build() {
      ModelImpl toReturn = obj;
      obj = null;
      toReturn.DialectProperties = org.jsonddl.impl.Protected.object(toReturn.DialectProperties);
      toReturn.EnumValues = org.jsonddl.impl.Protected.object(toReturn.EnumValues);

      toReturn.Properties = org.jsonddl.impl.Protected.object(toReturn.Properties);
      return toReturn;
    }
    public Model.Builder builder() {
      return this;
    }
    public Model.Builder from(Model copyFrom) {
      withComment(copyFrom.getComment());
      withDialectProperties(copyFrom.getDialectProperties());
      withEnumValues(copyFrom.getEnumValues());
      withName(copyFrom.getName());
      withProperties(copyFrom.getProperties());
      return this;
    }
    public Model.Builder from(java.util.Map<String, Object> map) {
      accept(org.jsonddl.impl.JsonMapVisitor.fromJsonMap(map));
      return this;
    }
    public Class<Model> getDdlObjectType() {
      return Model.class;
    }
    public Model.Builder newInstance() {
      return new Model.Builder();
    }
    public java.util.Map<String, Object> toJsonObject() {
      return obj.toJsonObject();
    }
    public Model.Builder traverse(org.jsonddl.JsonDdlVisitor visitor) {
      withComment(
      new org.jsonddl.impl.ContextImpl.ValueContext.Builder<java.lang.String>()
        .withKind(org.jsonddl.model.Kind.STRING)
        .withLeafType(java.lang.String.class)
        .withMutability(true)
        .withProperty("comment")
        .withValue(obj.Comment)
        .build().traverse(visitor));
      withDialectProperties(
      new org.jsonddl.impl.ContextImpl.ValueContext.Builder<java.util.Map<java.lang.String, java.util.Map<java.lang.String, java.lang.String>>>()
        .withKind(org.jsonddl.model.Kind.MAP)
        .withNestedKinds(java.util.Arrays.asList(org.jsonddl.model.Kind.STRING, 
                                                 org.jsonddl.model.Kind.MAP, org.jsonddl.model.Kind.STRING, 
                                                 org.jsonddl.model.Kind.STRING))
        .withLeafType(java.lang.String.class)
        .withMutability(true)
        .withProperty("dialectProperties")
        .withValue(obj.DialectProperties)
        .build().traverse(visitor));
      withEnumValues(
      new org.jsonddl.impl.ContextImpl.ListContext.Builder<EnumValue>()
        .withKind(org.jsonddl.model.Kind.LIST)
        .withNestedKinds(java.util.Arrays.asList(org.jsonddl.model.Kind.DDL))
        .withLeafType(EnumValue.class)
        .withMutability(true)
        .withProperty("enumValues")
        .withValue(obj.EnumValues)
        .build().traverse(visitor));
      withName(
      new org.jsonddl.impl.ContextImpl.ValueContext.Builder<java.lang.String>()
        .withKind(org.jsonddl.model.Kind.STRING)
        .withLeafType(java.lang.String.class)
        .withMutability(true)
        .withProperty("name")
        .withValue(obj.Name)
        .build().traverse(visitor));
      withProperties(
      new org.jsonddl.impl.ContextImpl.ListContext.Builder<Property>()
        .withKind(org.jsonddl.model.Kind.LIST)
        .withNestedKinds(java.util.Arrays.asList(org.jsonddl.model.Kind.DDL))
        .withLeafType(Property.class)
        .withMutability(true)
        .withProperty("properties")
        .withValue(obj.Properties)
        .build().traverse(visitor));
      return this;
    }
    public byte[] computeDigest() {
      byte[] digest;
      org.jsonddl.impl.DigestVisitor v = new org.jsonddl.impl.DigestVisitor();
      accept(v);
      digest = v.getDigest();
      return digest;
    }

    public int hashCode() {
      byte[] digest = computeDigest();
      return (int)((digest[0] << 3) | (digest[1] << 2) | (digest[18] << 1) | digest[19]);
    }

    public boolean equals(Object o) {
      if (o == this) {
        return true;
      }
      if (!(o instanceof org.jsonddl.impl.Digested)) {
        return false;
      }
      byte[] d1 = computeDigest();
      byte[] d2 = ((org.jsonddl.impl.Digested) o).computeDigest();
      for (int i = 0, j = d1.length; i<j; i++) {
        if (d1[i] != d2[i]) {
          return false;
        }
      }
      return true;
    }

    /**
     * For debugging use only.
     */
    public String toString() {
      return org.jsonddl.impl.JsonMapVisitor.toString(this);
    }
    /**
     * Convenience method for adding members to the {@code enumValues} property. If the
     * {@code enumValues} property has not been previously set, it will be initialized with an
     * empty list. If the current value of {@code enumValues} is immutable, it will be replaced
     * with a mutable list.
     */
    public Model.Builder addEnumValues(EnumValue element) {
      if (obj.EnumValues == null) {
        obj.EnumValues = new java.util.ArrayList<EnumValue>();
      }
      try {
        obj.EnumValues.add(element);
      } catch (java.lang.UnsupportedOperationException e) {
        obj.EnumValues = new java.util.ArrayList<EnumValue>(obj.EnumValues);
        obj.EnumValues.add(element);
      }
      return this;
    }


    /**
     * Convenience method for adding members to the {@code properties} property. If the
     * {@code properties} property has not been previously set, it will be initialized with an
     * empty list. If the current value of {@code properties} is immutable, it will be replaced
     * with a mutable list.
     */
    public Model.Builder addProperties(Property element) {
      if (obj.Properties == null) {
        obj.Properties = new java.util.ArrayList<Property>();
      }
      try {
        obj.Properties.add(element);
      } catch (java.lang.UnsupportedOperationException e) {
        obj.Properties = new java.util.ArrayList<Property>(obj.Properties);
        obj.Properties.add(element);
      }
      return this;
    }

    public java.lang.String getComment() {
      return obj.Comment;
    }

    public java.util.Map<java.lang.String, java.util.Map<java.lang.String, java.lang.String>> getDialectProperties() {
      return obj.DialectProperties;
    }

    public java.util.List<EnumValue> getEnumValues() {
      return obj.EnumValues;
    }

    public java.lang.String getName() {
      return obj.Name;
    }

    public java.util.List<Property> getProperties() {
      return obj.Properties;
    }

    public void setComment(java.lang.String value) {
      withComment(value);
    }
    /**
         * A two-level map that breaks out per-dialect properties to be consumed by
         * the dialect code-generators.
         */
    public void setDialectProperties(java.util.Map<java.lang.String, java.util.Map<java.lang.String, java.lang.String>> value) {
      withDialectProperties(value);
    }

    public void setEnumValues(java.util.List<EnumValue> value) {
      withEnumValues(value);
    }

    public void setName(java.lang.String value) {
      withName(value);
    }

    public void setProperties(java.util.List<Property> value) {
      withProperties(value);
    }
    /**
     * Convenience method for adding members to the {@code dialectProperties} property. If the
     * {@code dialectProperties} property has not been previously set, it will be initialized with an
     * empty map. If the current value of {@code dialectProperties} is immutable, it will be replaced
     * with a mutable map.
     */
    public Model.Builder putDialectProperties(
        java.lang.String key, java.util.Map<java.lang.String, java.lang.String> value) {
      if (obj.DialectProperties == null) {
        obj.DialectProperties = new java.util.LinkedHashMap<java.lang.String, java.util.Map<java.lang.String, java.lang.String>>();
      }
      try {
        obj.DialectProperties.put(key, value);
      } catch (java.lang.UnsupportedOperationException e) {
        obj.DialectProperties = new java.util.LinkedHashMap<java.lang.String, java.util.Map<java.lang.String, java.lang.String>>(obj.DialectProperties);
        obj.DialectProperties.put(key, value);
      }
      return this;
    }




    public Model.Builder withComment(java.lang.String value) {
      obj.Comment = value;
      return this;
    }
    /**
         * A two-level map that breaks out per-dialect properties to be consumed by
         * the dialect code-generators.
         */
    public Model.Builder withDialectProperties(java.util.Map<java.lang.String, java.util.Map<java.lang.String, java.lang.String>> value) {
      obj.DialectProperties = value;
      return this;
    }

    public Model.Builder withEnumValues(java.util.List<EnumValue> value) {
      obj.EnumValues = value;
      return this;
    }

    public Model.Builder withName(java.lang.String value) {
      obj.Name = value;
      return this;
    }

    public Model.Builder withProperties(java.util.List<Property> value) {
      obj.Properties = value;
      return this;
    }
  }
  Builder builder();
  java.lang.String getComment();
  /**
       * A two-level map that breaks out per-dialect properties to be consumed by
       * the dialect code-generators.
       */
  java.util.Map<java.lang.String, java.util.Map<java.lang.String, java.lang.String>> getDialectProperties();

  java.util.List<EnumValue> getEnumValues();

  java.lang.String getName();

  java.util.List<Property> getProperties();
  Builder newInstance();
}