package org.jsonddl.model;
/**
   * A Schema is the top-level object that encapsulates the normalized form of a
   * json-ddl schema.
   */
@javax.annotation.Generated(value="org.jsonddl.generator.industrial.IndustrialDialect", date="2012-06-23T18:24:31")
public interface Schema
    extends org.jsonddl.JsonDdlObject<Schema>
 {
  /**
   * Constructs instances of {@link Schema}. Instances of Builder should not be
   * reused after calling {@link #build()}.
   */
  @javax.annotation.Generated(value="org.jsonddl.generator.industrial.IndustrialDialect", date="2012-06-23T18:24:31")
  public static class Builder
      implements org.jsonddl.JsonDdlObject.Builder<Schema>,  org.jsonddl.impl.Traversable<Schema>, org.jsonddl.impl.Digested, Schema {
    private SchemaImpl obj;
    public Builder() {
      this(new SchemaImpl());
    }
    Builder(SchemaImpl instance) {
      this.obj = instance;
    }
    public Schema.Builder accept(org.jsonddl.JsonDdlVisitor visitor) {
      obj = new org.jsonddl.impl.ContextImpl.ObjectContext.Builder<Schema>()
          .withValue(this)
          .withKind(org.jsonddl.model.Kind.DDL)
          .withMutability(true)
          .build().traverse(visitor).builder().obj;
      return this;
    }
    public Schema build() {
      SchemaImpl toReturn = obj;
      obj = null;
      toReturn.Models = org.jsonddl.impl.Protected.object(toReturn.Models);
      return toReturn;
    }
    public Schema.Builder builder() {
      return this;
    }
    public Schema.Builder from(Schema copyFrom) {
      withComment(copyFrom.getComment());
      withModels(copyFrom.getModels());
      return this;
    }
    public Schema.Builder from(java.util.Map<String, Object> map) {
      accept(org.jsonddl.impl.JsonMapVisitor.fromJsonMap(map));
      return this;
    }
    public Class<Schema> getDdlObjectType() {
      return Schema.class;
    }
    public Schema.Builder newInstance() {
      return new Schema.Builder();
    }
    public java.util.Map<String, Object> toJsonObject() {
      return obj.toJsonObject();
    }
    public Schema.Builder traverse(org.jsonddl.JsonDdlVisitor visitor) {
      withComment(
      new org.jsonddl.impl.ContextImpl.ValueContext.Builder<java.lang.String>()
        .withKind(org.jsonddl.model.Kind.STRING)
        .withLeafType(java.lang.String.class)
        .withMutability(true)
        .withProperty("comment")
        .withValue(obj.Comment)
        .build().traverse(visitor));
      withModels(
      new org.jsonddl.impl.ContextImpl.MapContext.Builder<Model>()
        .withKind(org.jsonddl.model.Kind.MAP)
        .withNestedKinds(java.util.Arrays.asList(org.jsonddl.model.Kind.STRING, 
                                                 org.jsonddl.model.Kind.DDL))
        .withLeafType(Model.class)
        .withMutability(true)
        .withProperty("models")
        .withValue(obj.Models)
        .build().traverse(visitor));
      return this;
    }
    public byte[] computeDigest() {
      byte[] digest;
      org.jsonddl.impl.DigestVisitor v = new org.jsonddl.impl.DigestVisitor();
      accept(v);
      digest = v.getDigest();
      return digest;
    }

    public int hashCode() {
      byte[] digest = computeDigest();
      return (int)((digest[0] << 3) | (digest[1] << 2) | (digest[18] << 1) | digest[19]);
    }

    public boolean equals(Object o) {
      if (o == this) {
        return true;
      }
      if (!(o instanceof org.jsonddl.impl.Digested)) {
        return false;
      }
      byte[] d1 = computeDigest();
      byte[] d2 = ((org.jsonddl.impl.Digested) o).computeDigest();
      for (int i = 0, j = d1.length; i<j; i++) {
        if (d1[i] != d2[i]) {
          return false;
        }
      }
      return true;
    }

    /**
     * For debugging use only.
     */
    public String toString() {
      return org.jsonddl.impl.JsonMapVisitor.toString(this);
    }
    public java.lang.String getComment() {
      return obj.Comment;
    }

    public java.util.Map<java.lang.String, Model> getModels() {
      return obj.Models;
    }

    /**
         * General information about the schema itself.
         */
    public void setComment(java.lang.String value) {
      withComment(value);
    }
    /**
         * A map of object models by simple name.
         */
    public void setModels(java.util.Map<java.lang.String, Model> value) {
      withModels(value);
    }
    /**
     * Convenience method for adding members to the {@code models} property. If the
     * {@code models} property has not been previously set, it will be initialized with an
     * empty map. If the current value of {@code models} is immutable, it will be replaced
     * with a mutable map.
     */
    public Schema.Builder putModels(
        java.lang.String key, Model value) {
      if (obj.Models == null) {
        obj.Models = new java.util.LinkedHashMap<java.lang.String, Model>();
      }
      try {
        obj.Models.put(key, value);
      } catch (java.lang.UnsupportedOperationException e) {
        obj.Models = new java.util.LinkedHashMap<java.lang.String, Model>(obj.Models);
        obj.Models.put(key, value);
      }
      return this;
    }

    /**
         * General information about the schema itself.
         */
    public Schema.Builder withComment(java.lang.String value) {
      obj.Comment = value;
      return this;
    }
    /**
         * A map of object models by simple name.
         */
    public Schema.Builder withModels(java.util.Map<java.lang.String, Model> value) {
      obj.Models = value;
      return this;
    }
  }
  Builder builder();
  /**
       * General information about the schema itself.
       */
  java.lang.String getComment();
  /**
       * A map of object models by simple name.
       */
  java.util.Map<java.lang.String, Model> getModels();
  Builder newInstance();
}